//Global variables

var beans=new Array(48);
var beanlocs=new Array(48);
var bowls=new Array(14);
var blockInput=false;
var mouseisdown=false;
var timer=null;
var timerparam=null;
var playerObject=null;
var soundFile=new Array(3);

//Main functions

function initializeVariables(){
	bowls[6]=bowl2;bowls[13]=bowl1;
	bowls[0]=bowl21;bowls[1]=bowl22;bowls[2]=bowl23;bowls[3]=bowl24;bowls[4]=bowl25;bowls[5]=bowl26;
	bowls[12]=bowl11;bowls[11]=bowl12;bowls[10]=bowl13;bowls[9]=bowl14;bowls[8]=bowl15;bowls[7]=bowl16;
	beans[0]=bean0;beans[1]=bean1;beans[2]=bean2;beans[3]=bean3;beans[4]=bean4;beans[5]=bean5;beans[6]=bean6;beans[7]=bean7;
	beans[8]=bean8;beans[9]=bean9;beans[10]=bean10;beans[11]=bean11;beans[12]=bean12;beans[13]=bean13;beans[14]=bean14;beans[15]=bean15;
	beans[16]=bean16;beans[17]=bean17;beans[18]=bean18;beans[19]=bean19;beans[20]=bean20;beans[21]=bean21;beans[22]=bean22;beans[23]=bean23;
	beans[24]=bean24;beans[25]=bean25;beans[26]=bean26;beans[27]=bean27;beans[28]=bean28;beans[29]=bean29;beans[30]=bean30;beans[31]=bean31;
	beans[32]=bean32;beans[33]=bean33;beans[34]=bean34;beans[35]=bean35;beans[36]=bean36;beans[37]=bean37;beans[38]=bean38;beans[39]=bean39;
	beans[40]=bean40;beans[41]=bean41;beans[42]=bean42;beans[43]=bean43;beans[44]=bean44;beans[45]=bean45;beans[46]=bean46;beans[47]=bean47;
	for (i=0;i<3;i++) soundFile[i]=storage.extract("sounds/bean"+(i+1)+".wav");
	playerObject=new ActiveXObject("WMPlayer.OCX");
	playerObject.uiMode="none";
	playerObject.settings.setMode("autoRewind",true);
	playerObject.settings.autoStart = true;	 
}
function getBowlNr(idNr){
	if (idNr==1 || idNr==2) return 14/idNr-1;
	else if (idNr>10 && idNr<17) return 23-idNr;
	else if (idNr>20 && idNr<27) return idNr-21;
	else -1;
}
function moveBean(beanNr,bowlNr,id){
	if (beanNr<0 || beanNr>47) return;
	if (!id && bowlNr==0){
		beans[beanNr].x=-10;
		beans[beanNr].y=-10;
		return;
	}
	if (!id) bowlNr=getBowlNr(bowlNr);
	if (bowlNr<0) return;
	if (bowlNr!=6 && bowlNr!=13){
		x=Math.floor(Math.random()*15)+3;
		if (x==3 || x==17) y=Math.floor(Math.random()*2)+5; else y=Math.floor(Math.random()*2*(3-Math.round(Math.abs(x-10)/3)))+Math.round(Math.abs(x-10)/3)+2;
	}else{
		x=Math.floor(Math.random()*19)+3;
		if (x==3 || x==21) y=8; else if (x==4 || x==20) y=Math.floor(Math.random()*3)+7; else y=Math.floor(Math.random()*(2*(5-(Math.abs(x-12)+2)/3)+1))+(Math.abs(x-12)+11)/3;
	}
	beans[beanNr].x=bowls[bowlNr].x+x;
	beans[beanNr].y=bowls[bowlNr].y+y;
	beans[beanNr].tooltip=bowlNr;
}
function drawInterface(){
	mainarea.appendElement('<button name="bowl1" image="images/bowlorange.png" width="40" height="40" tooltip="0" x="0" y="22"/>');
	for (i=1;i<=6;i++) for (j=1;j<=2;j++) mainarea.appendElement('<button name="bowl'+(j*10+i)+'" image="images/bowl'+(j==1?'orange':'blue')+'.png" '+(j==2?'downImage="images/bowldown.png" onmousedown="bowlMDown(2'+i+')" onmouseup="bowlMUp(2'+i+')" onclick="bowlClick(2'+i+')" onmouseover="bowlMOver(2'+i+')" onmouseout="bowlMOut(2'+i+')" ':'')+'tooltip="4" width="36" height="30" x="'+(33*i)+'" y="'+(40*j-33)+'"/>');
	mainarea.appendElement('<button name="bowl2" image="images/bowlblue.png" width="40" height="40" tooltip="0" x="230" y="22"/>');
	for (i=0;i<2;i++) for (j=0;j<4;j++) for (k=0;k<6;k++)	mainarea.appendElement('<img name="bean'+(24*i+6*j+k)+'" src="images/bean'+(j+1)+'.gif" width="10" height="10" />');
	mainarea.appendElement('<button width="50" height="20" x="215" y="80" image="images/quit.png" overImage="images/quitover.png" downImage="images/quitdown.png" onclick="quitClick()"/>')
	mainarea.appendElement('<label name="status_bar" x="0" y="82" width="210" height="16" color="#000000" font="Arial" size="10" bold="true"></label>');
}
function setStartingPosition(){
	for (i=0;i<2;i++) for (j=0;j<4;j++) for (k=0;k<6;k++) moveBean(24*i+6*j+k,10*i+k+11,false);
	bowls[6].tooltip=bowls[13].tooltip="0";
	for (i=0;i<6;i++) bowls[i].tooltip="4";
	for (i=7;i<13;i++) bowls[i].tooltip="4";
	status_bar.innerText="Score   -   You : 24 / Friend : 24";
}
function playSound(nr){
	playlist=playerObject.newPlaylist("","");
	newMedia=playerObject.newMedia(soundFile[nr]);
	playlist.appendItem(newMedia);
	playerObject.currentPlaylist=playlist;
}
function setScores(){
	var you=0;
	var opp=0;
	for (i=0;i<7;i++) you+=parseInt(bowls[i].tooltip,10);
	for (i=7;i<14;i++) opp+=parseInt(bowls[i].tooltip,10);
	status_bar.innerText="Score   -   You : "+you+" / Friend : "+opp;
	if (bowls[6].tooltip==you || bowls[13].tooltip==opp){
		alert("Game Over\n"+(you==opp?"It's a draw":"You have "+(you>opp?"won":"lost"))+" !\nFinal score :\nYou : "+you+"\nYour friend : "+opp);
		friendUID=null;
		timer=null;
		changeView(mainarea,friendsarea,true);
	}
}
function captureBeans(bowlNr){
	for (i=0;i<48 && beans[i].tooltip!=bowlNr;i++);
	if (i<48){
		playSound(Math.floor(Math.random()*3));
		moveBean(i,6,true);
		beans[i].tooltip="6";
		bowls[bowlNr].tooltip="0";
		bowls[6].tooltip++;
		timer=setTimeout("captureBeans(timerparam)",350);
	}else if(bowlNr<6){
		timerparam=12-bowlNr;
		captureBeans(timerparam);
	}else setScores();
}
function makeMoves(curBowl){
	playSound(Math.floor(Math.random()*3));
	for (i=0;i<48 && beans[i].x>-10;i++);
	moveBean(i,curBowl,true);
	beans[i].tooltip=curBowl;
	bowls[curBowl].tooltip++;
	for (;i<48 && beans[i].x>-10;i++);
	if (i<48){
		timerparam++;
		if (timerparam==13) timerparam=0;
		timer=setTimeout("makeMoves(timerparam)",350);
	}else{
		if (curBowl==6){
			setScores();
			status_bar.innerText="Please wait... Synchronizing...";
		}
		else if (curBowl<6 && bowls[curBowl].tooltip==1){
			status_bar.innerText="CAPTURE !!!";
			timer=setTimeout("captureBeans(timerparam)",350)
		}
		else setScores();
	}
}
function captureEnemyBeans(bowlNr){
	for (i=0;i<48 && beans[i].tooltip!=bowlNr;i++);
	if (i<48){
		playSound(Math.floor(Math.random()*3));
		moveBean(i,13,true);
		beans[i].tooltip="13";
		bowls[bowlNr].tooltip="0";
		bowls[13].tooltip++;
		timer=setTimeout("captureEnemyBeans(timerparam)",350);
	}else if(bowlNr>6 && bowlNr<13){
		timerparam=12-bowlNr;
		captureEnemyBeans(timerparam);
	}else{
		setScores();
		blockInput=false;
	}
}
function makeEnemyMoves(curBowl){
	playSound(Math.floor(Math.random()*3));
	for (i=0;i<48 && beans[i].x>-10;i++);
	moveBean(i,curBowl,true);
	beans[i].tooltip=curBowl;
	bowls[curBowl].tooltip++;
	for (;i<48 && beans[i].x>-10;i++);
	if (i<48){
		timerparam++;
		if (timerparam==14) timerparam=0;
		if (timerparam==6) timerparam=7
		timer=setTimeout("makeEnemyMoves(timerparam)",350);
	}else{
		if (curBowl>6 && curBowl<13 && bowls[curBowl].tooltip==1){
			status_bar.innerText="CAPTURE !!!";
			timer=setTimeout("captureEnemyBeans(timerparam)",350)
		}
		else{
			setScores();
			if (curBowl!=13) blockInput=false; else{
				status_bar.innerText="Your friend got an extra move...";
				googleTalk.SendTalkData(friendUID,uniqueID+":confirmmove");
			}
		}
	}
}

//Event functions

function bowlMDown(bowlNr){
	bowlNr=getBowlNr(bowlNr);
	if (blockInput || bowls[bowlNr].tooltip=="0"){
		event.returnValue=false;
		return;
	}
	bowls[bowlNr].width=32;
	bowls[bowlNr].height=40;
	bowls[bowlNr].y-=10;
	for (i=0;i<48;i++) if (beans[i].tooltip==bowlNr) moveBean(i,0,false);
	mouseisdown=true;
}
function bowlMUp(bowlNr){
	if (blockInput){
		event.returnValue=false;
		return;
	}
	bowlNr=getBowlNr(bowlNr);
	bowls[bowlNr].width=36;
	bowls[bowlNr].height=30;
	bowls[bowlNr].y=47;
	mouseisdown=false;
	bowls[bowlNr].image="images/bowlblue.png";
	timer=setTimeout("for (i=0;i<48;i++) if (beans[i].x==-10) moveBean(i,beans[i].tooltip,true);",100);
}
function bowlMOver(bowlNr){
	bowlNr=getBowlNr(bowlNr);
	if (blockInput || bowls[bowlNr].tooltip=="0"){
		event.returnValue=false;
		return;
	}
	bowls[bowlNr].image="images/bowlover.png";
}
function bowlMOut(bowlNr){
	if (mouseisdown || blockInput){
		event.returnValue=false;
		return;
	}
	bowlNr=getBowlNr(bowlNr);
	bowls[bowlNr].image="images/bowlblue.png";
}
function bowlClick(bowlNr){
	bowlNr=getBowlNr(bowlNr);
	if (blockInput || bowls[bowlNr].tooltip=="0"){
		event.returnValue=false;
		return;
	}
	blockInput=true;
	if (timer!=null){
		clearInterval(timer);
		timer=null;
	}
	googleTalk.SendTalkData(friendUID,uniqueID+"move:"+bowlNr);
	timerparam=bowlNr;
	bowls[timerparam].tooltip="0";
	timerparam++;
	timer=setTimeout("makeMoves(timerparam)",350);
}
function quitClick(){
	if (confirm("Are you sure you want to quit this game ?")){
		googleTalk.SendTalkData(friendUID,uniqueID+":quit");
		changeView(mainarea,friendsarea,true);
		friendUID=null;
	}
}

//Main program entry point

drawInterface();
initializeVariables();
changeView(mainarea,friendsarea,true);